clc
clear
% 
load('\\BIO.AAU.DK\A 2bar 160 1 traced.mat') %Loads tracer data, enter adress
run('\\BIO.AAU.DK\Filterfunction.m') %Filters data from "tracer"
tracer=matrice;
run('\\BIO.AAU.DK\Velocities.m') %Calculates velocities

%

clear speed


Sorted=sortrows(Velocities,-2);
ii=0;
rowsToDelete=[];
xx=1;

step=1;
for i=0:step:160
    min=(i);
    max=i+step;
    [row] = find(Sorted(:,2)>=min & Sorted(:,2)<max);
    speed(ii+1,1)=i;
    speed(ii+1,2)=mean(Sorted(row,3));
    speed(ii+1,3)=std(Sorted(row,3));
    rakken(ii+1).r=row;
    
   
    
    for iii=1:length(row)
        if Sorted(row(iii),3)<=speed(ii+1,2)-speed(ii+1,3) || Sorted(row(iii),3)>=speed(ii+1,2)+speed(ii+1,3)
            rowsToDelete(xx,1)=row(iii);
            xx=xx+1;
        end
    end
    
    
    
    ii=ii+1;
    
end

close all
figure('Name','average speed')
sz=1;
scatter(speed(:,1),speed(:,2),sz);
axis([0 140 0 150000])
set(gca,'FontSize',12)
xlabel('Distance [um]') 
ylabel('Average speed of particles [um/s]') 
axis([0 140 0 100000])
reducedSorted=Sorted;
reducedSorted(rowsToDelete,:)=[];

ii=0;
for i=0:step:140
    min=(i);
    max=i+step;
    [row] = find(Sorted(:,2)>=min & Sorted(:,2)<max);
    speed(ii+1,1)=i;
    speed(ii+1,2)=mean(Sorted(row,3));
    speed(ii+1,3)=std(Sorted(row,3));
    rakken(ii+1).r=row;
    

    ii=ii+1;
    
end


figure('Name','Total speed')
sz=1;
scatter(reducedSorted(:,2),reducedSorted(:,3),sz)
axis([0 120 0 150000])
set(gca,'FontSize',12)
xlabel('Distance [um]') 
ylabel('Speed of all particles [um/s]') 

% figure('Name','Total speed -std outlier')
% sz=1;
% scatter(reducedSorted(:,2),reducedSorted(:,3),sz)
% 
figure('Name','Speed across fiber')
sz=1;
scatter(Sorted(:,2),Sorted(:,4),sz);
xlabel('um') 
ylabel('um/s') 
% % 
figure('Name','Speed towards fiber')
sz=1;
scatter(Sorted(:,2),Sorted(:,5),sz);
xlabel('um') 
ylabel('um/s') 
% 
% figure('Name','Tracked coordinates')
% sz=1;
% scatter(Sorted(:,1),Sorted(:,2),sz);

% figure('Name','average speed -std')
% sz=1;
% scatter(speed(:,1),speed(:,2),sz);
% xlabel('um') 
% ylabel('um/s') 



speed(:,4)=speed(:,2)+speed(:,3);
speed(:,5)=speed(:,2)-speed(:,3);



figure('Name','Total speed with mean and std')
sz=1;
scatter(reducedSorted(:,2),reducedSorted(:,3),sz)
xlabel('um') 
ylabel('um/s') 
hold on
sz=25;
c='k';
scatter(speed(:,1),speed(:,2),sz,'filled',c);
scatter(speed(:,1),speed(:,4),sz,c);
scatter(speed(:,1),speed(:,5),sz,c);
%axis([25 120 -.5 150000]);
xlswrite('SpeedProfiles.xlsx', Sorted, 'C2bar160_1') %saves velocity profiles
