%tracing



%  clear
%  clc
% %load('A 2bar 160 1-converted-converted.mat')
% 
% 
% 
% videofiledir = dir('C:\Users\Boe\Dropbox\1Speciale\Traced mappe\Gradient\*.mat'); 
% nfiles = length(videofiledir);
% 
% for ii=1:nfiles
% %currentfilename=videofiledir(ii).name;
% clear ParPos;
% clear tracer;
% 
% figure
% load(videofiledir(ii).name);






amountofframes=length(ParPos(:))-1;

tracenumber=1;      %Variable to keep track on number of tracked particles
tracer=[];          %Saves tracked particle positions
tic
    %for the amount of frames
for frame=1:amountofframes

    for particlenumber=1:length(ParPos(frame).xy(1,:))
        
        %Testing if there is a particle that fits within the area

        L = linspace(0,2*pi,6);
        xv = ParPos(frame).xy(1,particlenumber)-30+cos(L)*50';    % the area around x and y that we recognize as a trace
        yv = ParPos(frame).xy(2,particlenumber)+2+sin(L)*5';    

        xq=ParPos(frame+1).xy(1,:);     %Defining x and y values that are tested
        yq = ParPos(frame+1).xy(2,:);

        [in] = inpolygon(xq,yq,xv,yv);  
        
        

        
        %Saving pairs
            for lengthin=1:length(in)   
                lengthins=lengthin;
                    
                if in(lengthin)==true
        
                    %Finds out if there is a new trace or of particle is
                    %registered before
                        if ismember(ParPos(frame).xy(1,particlenumber),tracer(:,:))==true          %tester for at se om partiklen er i et andet trace
                    
                        [row,col]=find(tracer==ParPos(frame).xy(1,particlenumber));        %Finder positionen af den fundne partikel
                        kolonne=col;
                        tracer(row(end),col(end)+1)=ParPos(frame+1).xy(1,lengthins);                  %Saving the x and then y postion of new found point in old trace after the found position
                        tracer(row(end)+1,col(end)+1)=ParPos(frame+1).xy(2,lengthins);
                        
                        else
                        tracer(tracenumber*2-1,1)=ParPos(frame).xy(1,particlenumber);            % Frst gemmes det originale punkt herefter gemmes det fundne
                        tracer(tracenumber*2,1)=ParPos(frame).xy(2,particlenumber);
                   
                        tracer(tracenumber*2-1,2)=ParPos(frame+1).xy(1,lengthins);
                        tracer(tracenumber*2,2)=ParPos(frame+1).xy(2,lengthins);
                        tracenumber=tracenumber+1;
                        end
                    
                                        else
                                           if find(tracer==ParPos(frame).xy(1,particlenumber))==true          %tester for at se om partiklen er i et andet trace
            
                                           else
                                             %tracer(tracenumber*2-1,1)=ParPos(frame).xy(1,particlenumber);
                                             %tracer(tracenumber*2,1)=ParPos(frame).xy(2,particlenumber);
                                             %tracenumber=tracenumber+1;  
                                           end
                end 
        
               
                
                
            end
           % Illustrating pairing of coordinates
        figure(1)
        plot(xv,yv) % polygon
        axis([0 400 0 140])
        
        hold on
        plot(xq(in),yq(in),'r+') % points inside
        plot(xq(~in),yq(~in),'bo') % points outside
        hold off
        
        pause(0.1);
    end
         
end

save(strrep(videofiledir(ii).name,'-converted-converted',' traced'),'tracer');

   
toc
% end
