% Script to find particle velocities
col=1;
row=1;
hrow=1;
hcol=1;

clear Velocities

fps=1196;
pixeldistance=1.26; % Distance between pixels
[rowend,colend] = size(tracer);
rowend=rowend;
colend=colend;
two=2;

while rowend>row %&& colend>col
    
    
    
    %Saves start position for velocity along membrane
    Velocities(hrow,1)=tracer(row,col);    %x
    Velocities(hrow,2)=tracer(row+1,col);  %y
    
    %Saves total velocity
    Velocities(hrow,3)=(pixeldistance)*((tracer(row,col)-tracer(row,col+1))^2+(tracer(row+1,col)-tracer(row+1,col+1))^2)^(0.5)/(1/fps); %dividere med 1/1198 da det er det antal billeder per sekund filmen er filmet i
    
    %Saving velocity along fiber
    Velocities(hrow,4)=(pixeldistance)*(abs(tracer(row,col)-tracer(row,col+1))/(1/fps));
    
    %Saving velocity against fiber
    Velocities(hrow,5)=(pixeldistance)*(((tracer(row+1,col)-tracer(row+1,col+1)))/(1/fps));
    
    %Saving acceleration
    Velocities(hrow,6)=(pixeldistance)*((tracer(row+1,col+1)-tracer(row+1,col+2))-(tracer(row+1,col)-tracer(row+1,col+1)))/((1/fps)^2);

    
    hrow=hrow+1;
    col=col+1;
    weird=col+1;
    
    if colend==col+1              %Testing if we have reached the end
        col=1;
        row=row+2;
    end
    
    if tracer(row,col+1)==0     %Testing if the next element is 0
        col=1;
        row=row+2;
    end
    
    
end